/********************************************************************************/
/*  clickable.d																	*/
/*------------------------------------------------------------------------------*/
/*	製作		（　゜ワ゜）ノ　／　松久貫太									*/
/*	製作開始　	2007/12/06														*/
/*	MAIL		omega@personal.email.ne.jp										*/
/*	URL		http://nagoya.cool.ne.jp/o_mega										*/
/*																				*/
/*	このソースは「やわらかライセンス」の元で配布されています。					*/
/*-更新履歴---------------------------------------------------------------------*/
/*	2007/--/--																	*/
/*-その他-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/

/* ライブラリのインポート *******************************************************/
private import std.string;
private import vector;
private import hell2;

// koke依存拡張
class ImageButton{
	const int BUTTON_WIDTH = 80;
	const int BUTTON_HEIGHT = 32;
	
	int type;
	
	enum TYPE{
		UP_DEL,			// うp&削除
		HERBICIDE,		// 除草剤
		MANAGE_RAY,		// 運営レーザー
		CALL_NICO,		// ニコ厨を呼ぶ
		ROAD_ROLLER,	// ロードローラー
	}
	
	this(TYPE type){
		this.type = type;
	}
}

class ClickablePool{
	Clickable clist[];
	int count;
	const int MAX_COUNT = 32;
	
	string selected;
	
	this(){
		clist = new Clickable[MAX_COUNT];
		foreach(inout click ; clist) click = null;
		
		this.count = count;
		this.selected = "";
	}
	
	void add(string str,Vec3 pos,Vec3 size){
		Clickable newc = new Clickable(str,pos,size);
		
		foreach(inout c ; clist){
			if(!c){
				c = newc;
				return;
			}
		}
	}
	void add(string str,Vec3 pos,ImageButton.TYPE type){
		Vec3 size = new Vec3(ImageButton.BUTTON_WIDTH , ImageButton.BUTTON_HEIGHT , 0);
		Clickable newc = new Clickable(str , pos , size , 0 , new ImageButton(type));
		
		foreach(inout c ; clist){
			if(!c){
				c = newc;
				return;
			}
		}
	}
	
	string getMouseOver(){
		foreach(inout c ; clist){
			if(c && c.onMouse()){
				return c.str;
			}
		}
		return "";
	}
	
	string getMouseClick(){
		if(Hell_isPushMouse()) {
			string mov = getMouseOver();
			if(mov != "") selected = getMouseOver();
			return mov;
		}
		return "";
	}
	
	string getSelected(){return selected;}
	
	void draw(){
		foreach(inout c ; clist){
			if(c){
				if(c.str == selected){
					c.selected = true;
				}else{
					c.selected = false;
				}
				c.draw();
			}
		}
	}
}


class Clickable{
	Vec3 position;
	Vec3 size;
	string str;
	float zoom;
	bool selected;
	
	ImageButton imagebutton;
	
	this(string str,Vec3 pos,Vec3 size,float zoom = 2.0,ImageButton imagebutton = null){
		this.str = str;
		this.position = pos;
		this.size = size;
		this.zoom = zoom;
		this.imagebutton = imagebutton;
		this.selected = false;
	}
	
	bool onMouse(){
		if(position.x <= Hell_getMouseX() && position.x + size.x >= Hell_getMouseX()
			&& position.y <= Hell_getMouseY() && position.y + size.y >= Hell_getMouseY()) 
		{
			return true;
		}
		return false;
	}
	
	void draw(){
		if(imagebutton is null){
			// 通常
			if(onMouse()){
				Hell_drawFont(str , cast(int)position.x , cast(int)position.y , zoom , 255,128,32);
			}else{
				Hell_drawFont(str , cast(int)position.x , cast(int)position.y , zoom ,  64, 64, 64);
			}
		}else{
			// イメージボタンモード
			if(selected){			// 選択状態
				Hell_drawTexture("menu" , cast(int)position.x , cast(int)position.y
						, ImageButton.BUTTON_WIDTH * 2 , 0 , ImageButton.BUTTON_WIDTH , ImageButton.BUTTON_HEIGHT);
				Hell_drawTexture("menu" , cast(int)position.x , cast(int)position.y
						, 0 , (cast(int)imagebutton.type + 1) * ImageButton.BUTTON_HEIGHT
						, ImageButton.BUTTON_WIDTH , ImageButton.BUTTON_HEIGHT
						,1,1,0, 255,255,255);
			}else if(onMouse()){	// onMouse状態
				Hell_drawTexture("menu" , cast(int)position.x , cast(int)position.y
						, ImageButton.BUTTON_WIDTH , 0 , ImageButton.BUTTON_WIDTH , ImageButton.BUTTON_HEIGHT);
				Hell_drawTexture("menu" , cast(int)position.x , cast(int)position.y
						, 0 , (cast(int)imagebutton.type + 1) * ImageButton.BUTTON_HEIGHT
						, ImageButton.BUTTON_WIDTH , ImageButton.BUTTON_HEIGHT
						,1,1,0, 64,64,64);
			}else{					// 他
				Hell_drawTexture("menu" , cast(int)position.x , cast(int)position.y
						, 0 , 0 , ImageButton.BUTTON_WIDTH , ImageButton.BUTTON_HEIGHT);
				Hell_drawTexture("menu" , cast(int)position.x , cast(int)position.y
						, 0 , (cast(int)imagebutton.type + 1) * ImageButton.BUTTON_HEIGHT
						, ImageButton.BUTTON_WIDTH , ImageButton.BUTTON_HEIGHT
						,1,1,0, 64,64,64);
			}
		}
	}
}

/********************************************************************************/
